let AJAX_URL = data_object.url;

document.addEventListener("DOMContentLoaded", function () {
    let observer = new MutationObserver(function (mutations) {
        mutations.forEach(function (mutation) {

            if (mutation.type === "childList") {
                // Yeni eklenen payment_method inputlarının olup olmadığını kontrol et
                const newPaymentMethods = jQuery(mutation.addedNodes).find('input[name="payment_method"]');

                if (newPaymentMethods.length > 0) {
                    // Eğer event zaten atanmışsa bir daha atama
                    jQuery('input[name="payment_method"]').on("change", function () {

                        if (jQuery(this).val() === "woo_alttantire_hepsipay") {
                            console.log("ALT", "payment method change");
                            get_frame_options();

                        }
                    });
                }
            }

            if (mutation.addedNodes) {
                mutation.addedNodes.forEach(function (node) {
                    if (node.nodeType === 1 && node.matches("#payment")) {

                        console.log("ALT", "observer triggered", jQuery('input[name="payment_method"]:checked').val());

                        if (jQuery('input[name="payment_method"]:checked').val() === "woo_alttantire_hepsipay") {
                            get_frame_options();

                        }

                        observer.disconnect();
                    }
                });
            }
        });
    });

    observer.observe(document.body, {
        childList: true,
        subtree: true,
    });

    jQuery(document).ready(function ($) {


        $("#billing_phone").on("change", function () {

            console.log("ALT", "#billing_phone changed", $('input[name="payment_method"]:checked').val());

            if ($('input[name="payment_method"]:checked').val() === "woo_alttantire_hepsipay") {
                get_frame_options();

            }
        });

    });

});

///

function get_frame_options() {
    jQuery("#hepsipayFrameInit").html("");
    console.log("ALT", "get_frame_options");

    if (!jQuery("#billing_email").val() && !jQuery("#billing_phone").val()) {
        console.log("ALT", "billing_email billing_phone not found");

        return;
    }

    jQuery.ajax({
        url: AJAX_URL,
        type: "POST",

        data: {
            action: "handle_billing_data",
            billing_email: jQuery("#billing_email").val(),
            billing_phone: jQuery("#billing_phone").val(),
        },
        success: function (data) {
            data = JSON.parse(data);
            if (!data) {
                return;
            }

            if (data.message !== null) {
                jQuery(".payment_method_woo_alttantire_hepsipay .hepsipayMessage").html(
                    data.message,
                );

                return;
            }

            if (data.frameUrl !== null) {
                jQuery(".payment_method_woo_alttantire_hepsipay .hepsipayMessage").html(
                    "",
                );

                jQuery(".payment_method_woo_alttantire_hepsipay").show();
                // jQuery("body").trigger("update_checkout");
                console.log("ALT", "frameUrl", data.frameUrl);

                fire_frame(data.frameUrl);

            }
        },
        error: function (xhr, status, error) {
            console.log(xhr, status, error);
        },
    });
}

function fire_frame(frameUrl) {

    console.log("ALT", "fire_frame");

    const arg = {
        frameUrl: frameUrl,
        frameDivId: "hepsipayFrameInit",
        paymentStatusCallback: () => {
        },
        frameFailureCallback: () => {
        },
        onPaymentSuccessCallback: () => {
        },
        maxHeight: "800",
        disableDynamicHeight: false,
        showFramePaymentButton: false,
        useApiCallOnSuccessCallback: false,
        // selectedPaymentInfoCallback: callback,
        overrideFontFamily: "Inter",
        hideHeader: false,
    };

    setTimeout(() => {
        console.log("ALT", "HepsipaySdk.init");
        HepsipaySdk.init(arg);

    }, 500);

}

window.addEventListener("message", handle_message_events);

function handle_message_events(event) {
    const {messageType, ...data} = event.data;

    switch (messageType) {
        case "hp-payment-available-status":
            break;
        case "hp-restart-frame":
            get_frame_options();
            break;
        case "hp-payment-success":
            payment_success(data);
            break;
        case undefined:
            jQuery("html").animate(
                {
                    scrollTop: jQuery("#woo_alttantire_hepsipay-cc-form").offset().top,
                },
                800, //speed
            );
            break;

        default:
            break;
    }
}

function payment_success(hp_data) {
    if (!hp_data) return;

    jQuery.ajax({
        url: AJAX_URL,
        type: "POST",

        data: {
            action: "handle_payment_is_success",
            hp_payment_data: JSON.stringify(hp_data),
        },
        success: function (response) {
            let data = JSON.parse(response);
            window.location = data.redirect_url;
        },
        error: function (xhr, status, error) {
            console.log(xhr, status, error);
        },
    });
}
